#!/usr/bin/perl
use Device::Modem;

my $list = ',"Play/Pause",0,0,0,0';
$list .= ',"Prev",0,0,0,0';
$list .= ',"Next",0,0,0,0';
$list .= ',"Stop",0,0,0,0';
$list .= ',"Volume Up",0,0,0,0';
$list .= ',"Volume Down",0,0,0,0';

sub command {
	my $item = shift @_;
	print "Selected item: $item\n";

	if ($item == 0) {
		`dcop amarok default playPause`;
	} elsif ($item == 1) {
		`dcop amarok default prev`;
	} elsif ($item == 2) {
		`dcop amarok default next`;
	} elsif ($item == 3) {
		`dcop amarok default stop`;
	} elsif ($item == 4) {
		`dcop amarok default volumeUp`;
	} elsif ($item == 5) {
		`dcop amarok default volumeDown`;
	}
}
my $modem = new Device::Modem( port => '/dev/rfcomm0' );
unless ($modem->connect(baudrate => 115200, init_string => "Z")) {
	die "No connection with port /dev/rfcomm0!";
}
$modem->attention();

$modem->atsend("AT*SEAM=\"Amarok Control\",2\r");
($result, @lines) = $modem->parse_answer();
die "Failed to add menu entry" unless ($result eq "OK");
print @lines,"\n";

my $shown = 0;
while (true) {
	$result = $modem->answer("", 0);
	if ($result eq "") {
		$modem->wait(10);
	} elsif ($shown == 1) {
		print "sf $shown\n";
		$result =~ /\*SEGUII: (\d+),(\d+)(,(\d+))*/;
		if ($2 == 1) {
			print "Hiding menu\n";
			$modem->atsend("AT*SEUIS=0\r");
			($result, @lines) = $modem->parse_answer();
			die "Failed to terminate UI session" unless ($result eq "OK");
			$shown = 0;
		} elsif ($2 == 5) {
			command($4);
		}
	} else {
		print "Showing menu\n";
		$modem->atsend("AT*SEUIS=1\r");
		($result, @lines) = $modem->parse_answer();
		die "Failed to initialize UI session" unless ($result eq "OK");

		my $title = `dcop amarok default nowPlaying`;
		$title = "Amarok Stopped" if ($title eq "");
		$modem->atsend("AT*SELIST=\"$title\",3,0,6,1,1".$list."\r");
		($result, @lines) = $modem->parse_answer();
		die "Failed to create menu" unless ($result =~ /\*SESFI: \d+/);
		$shown = 1;
	}
}

$modem->disconnect();
